#ifndef LINEARWEIGHTSVALUEFUNCTION_H
#define LINEARWEIGHTSVALUEFUNCTION_H

#include <string>
#include "value_functions.h"
#include "ValueFunction.h"


class LinearWeightsValueFunction : public ValueFunction{

  double* m_w;
  
  // pointer to user preference function
  double (*m_value_function)(double* obj, int objsize, double* w);

 public:
  LinearWeightsValueFunction(int v);
  virtual ~LinearWeightsValueFunction();
  void setWeights(const std::string& weightstring);
  virtual double getValue(double* obj, int objsize) const;
  virtual bool setReady(int nobj);

 protected:
  void init();
  void setValueFunction(int v);
  bool generateWeights(int nobj);
};

#endif
