#ifndef POLYNOMIALVALUEFUNCTION_H
#define POLYNOMIALVALUEFUNCTION_H

#include "SimpleMatrix.h"
#include "ValueFunction.h"

class PolynomialValueFunction : public ValueFunction{

  typedef struct poly_weight_{  
    double w;
    int degree;
    int* index;    
  } poly_weight;  
  
  poly_weight* m_poly_weight;
  int m_poly_num_weights;
  int m_poly_degree;

 public:
  PolynomialValueFunction();
  virtual ~PolynomialValueFunction();
  virtual double getValue(double* obj, int objsize) const;
  bool generateWeights(int nobj);
  void setDegree(int d) {m_poly_degree = d;}
  void setWeightsNum(int n) {m_poly_num_weights = n;}
  virtual bool setReady(int nobj);
  void clean();
  double getValue(const vector<double>& obj) const;
  bool acceptableWeights(const Matrix<double>& M, const Matrix<double>& Mean, double thres) const;
  void printPolynomial() const;
  void readPolynomial(const std::string& buf);
  std::string toString() const;

 protected:
  void init();

};

#endif
