#ifndef USERPREFERENCE_H
#define USERPREFERENCE_H

#include <string>
#include "ValueFunction.h"

class UserPreference{

  ValueFunction* m_value_function;
  
 public:
  UserPreference();
  ~UserPreference();
  void setValueFunction(int v);
  void setWeights(const std::string& weightstring);
  double getValue(double* obj, int objsize) const;
  double getPreference(double* obj1, double* obj2, int objsize) const;
  bool setReady(int nobj) const {return m_value_function->setReady(nobj);}
  void setPolynomialDegree(int d);  
  void setPolynomialWeightsNum(int n);
  void setPolynomial(const std::string& pol);

 protected:
  void init();

};

#endif
