
#include "Utility.h"

using namespace std;

double eudistance(const vector<double>& x1, const vector<double>& x2)
{
  double dist = 0;
  
  for(unsigned int i = 0; i < x1.size(); i++)
    dist += (x1[i]-x2[i])*(x1[i]-x2[i]);
  return sqrt(dist); 
} 

double corrcoeff(const Matrix<double>& M)
{
  Matrix<double> S = M.SumR();
  Matrix<double> SS = M.dotProduct(M).SumR();

  double sumxy = M.GetCol(0).dotProduct(M.GetCol(1)).Sum();
  double n = M.GetNoRows();

  return (n*sumxy-S(0,0)*S(0,1)) / sqrt((n*SS(0,0)-S(0,0)*S(0,0))*(n*SS(0,1)-S(0,1)*S(0,1)));
}

double corrcoeff(const vector<int>& x1, const vector<int>& x2)
{
  Matrix<double> M(x1.size(),2);
  
  for(unsigned int i = 0; i < x1.size(); i++){
    M(i,0)=x1[i];
    M(i,1)=x2[i];
  }
  return corrcoeff(M);
}
